// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/services.proto

package proto

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "github.com/micro/micro/v3/service/api"
	client "github.com/micro/micro/v3/service/client"
	server "github.com/micro/micro/v3/service/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for ProductService service

func NewProductServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ProductService service

type ProductService interface {
	GetProductById(ctx context.Context, in *GetProductByIdRequest, opts ...client.CallOption) (*Product, error)
}

type productService struct {
	c    client.Client
	name string
}

func NewProductService(name string, c client.Client) ProductService {
	return &productService{
		c:    c,
		name: name,
	}
}

func (c *productService) GetProductById(ctx context.Context, in *GetProductByIdRequest, opts ...client.CallOption) (*Product, error) {
	req := c.c.NewRequest(c.name, "ProductService.GetProductById", in)
	out := new(Product)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ProductService service

type ProductServiceHandler interface {
	GetProductById(context.Context, *GetProductByIdRequest, *Product) error
}

func RegisterProductServiceHandler(s server.Server, hdlr ProductServiceHandler, opts ...server.HandlerOption) error {
	type productService interface {
		GetProductById(ctx context.Context, in *GetProductByIdRequest, out *Product) error
	}
	type ProductService struct {
		productService
	}
	h := &productServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ProductService{h}, opts...))
}

type productServiceHandler struct {
	ProductServiceHandler
}

func (h *productServiceHandler) GetProductById(ctx context.Context, in *GetProductByIdRequest, out *Product) error {
	return h.ProductServiceHandler.GetProductById(ctx, in, out)
}

// Api Endpoints for OrderService service

func NewOrderServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for OrderService service

type OrderService interface {
	CreateOrder(ctx context.Context, in *CreateOrderRequest, opts ...client.CallOption) (*Order, error)
}

type orderService struct {
	c    client.Client
	name string
}

func NewOrderService(name string, c client.Client) OrderService {
	return &orderService{
		c:    c,
		name: name,
	}
}

func (c *orderService) CreateOrder(ctx context.Context, in *CreateOrderRequest, opts ...client.CallOption) (*Order, error) {
	req := c.c.NewRequest(c.name, "OrderService.CreateOrder", in)
	out := new(Order)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for OrderService service

type OrderServiceHandler interface {
	CreateOrder(context.Context, *CreateOrderRequest, *Order) error
}

func RegisterOrderServiceHandler(s server.Server, hdlr OrderServiceHandler, opts ...server.HandlerOption) error {
	type orderService interface {
		CreateOrder(ctx context.Context, in *CreateOrderRequest, out *Order) error
	}
	type OrderService struct {
		orderService
	}
	h := &orderServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&OrderService{h}, opts...))
}

type orderServiceHandler struct {
	OrderServiceHandler
}

func (h *orderServiceHandler) CreateOrder(ctx context.Context, in *CreateOrderRequest, out *Order) error {
	return h.OrderServiceHandler.CreateOrder(ctx, in, out)
}

// Api Endpoints for DeliveryService service

func NewDeliveryServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for DeliveryService service

type DeliveryService interface {
	DeliverOrder(ctx context.Context, in *DeliverOrderRequest, opts ...client.CallOption) (*DeliveryResponse, error)
}

type deliveryService struct {
	c    client.Client
	name string
}

func NewDeliveryService(name string, c client.Client) DeliveryService {
	return &deliveryService{
		c:    c,
		name: name,
	}
}

func (c *deliveryService) DeliverOrder(ctx context.Context, in *DeliverOrderRequest, opts ...client.CallOption) (*DeliveryResponse, error) {
	req := c.c.NewRequest(c.name, "DeliveryService.DeliverOrder", in)
	out := new(DeliveryResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for DeliveryService service

type DeliveryServiceHandler interface {
	DeliverOrder(context.Context, *DeliverOrderRequest, *DeliveryResponse) error
}

func RegisterDeliveryServiceHandler(s server.Server, hdlr DeliveryServiceHandler, opts ...server.HandlerOption) error {
	type deliveryService interface {
		DeliverOrder(ctx context.Context, in *DeliverOrderRequest, out *DeliveryResponse) error
	}
	type DeliveryService struct {
		deliveryService
	}
	h := &deliveryServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&DeliveryService{h}, opts...))
}

type deliveryServiceHandler struct {
	DeliveryServiceHandler
}

func (h *deliveryServiceHandler) DeliverOrder(ctx context.Context, in *DeliverOrderRequest, out *DeliveryResponse) error {
	return h.DeliveryServiceHandler.DeliverOrder(ctx, in, out)
}
